---
title: Updating add-ons for Firefox 5
slug: Mozilla/Firefox/Releases/5/Updating_add-ons
tags:
  - Add-ons
  - Extensions
  - Firefox 5
---
<div>{{FirefoxSidebar}}</div><p>This article provides an overview of the changes you may need to make to your add-ons in order for them to work properly in Firefox 5. You can find a complete list of developer-related changes in Firefox 5 in <a href="/en/Firefox_5_for_developers" title="en/Firefox 5 for developers">Firefox 5 for developers</a>.</p>
<h2 id="Do_you_need_to_do_anything_at_all">Do you need to do anything at all?</h2>
<p>If your add-on is distributed on <a class=" external" href="http://addons.mozilla.org" title="http://addons.mozilla.org/">addons.mozilla.org</a> (AMO), it's been checked by an automated compatibility verification tool. Add-ons that don't use APIs that changed in Firefox 5, and have no binary components (which <a href="/En/Developer_Guide/Interface_Compatibility#Binary_Interfaces" title="En/Developer Guide/Interface Compatibility#Binary Interfaces">need to be recompiled for every major Firefox release</a>), have automatically been updated on AMO to indicate that they work in Firefox 5.</p>
<p>So you should start by visiting AMO and looking to see if your add-on needs any work done at all.</p>
<div class="note"><strong>Note:</strong> You should still test your add-on on Firefox 5, even if it's been automatically upgraded. There are edge cases that may not be automatically detected.</div>
<p>Once you've confirmed that you need to make changes, come on back to this page and read on.</p>
<h2 id="User_interface_related_changes">User interface related changes</h2>
<p>Due to the short development cycle (even for our rapid release cycle; Firefox 5 was on an extra-short schedule for timing reasons), there are very few UI related changes in Firefox 5.</p>
<h3 id="Determining_the_UI_language">Determining the UI language</h3>
<p>In the past, the {{ domxref("window.navigator.language") }} DOM property reflected the language of Firefox's user interface. This is no longer the case; instead, it reflects the value of the <code>Accept-Language</code> header for the current document. If you need to detect the UI language, you should instead look at the value of the <code>general.useragent.locale</code> preference.</p><h2 id="DOM_changes">DOM changes</h2>
<p>The behaviors of {{ domxref("window.setTimeout()") }} and {{ domxref("window.setInterval()") }} have changed; the minimum allowed time has changed, and <a href="/En/Window.setTimeout#Minimum_delay_and_timeout_nesting" title="En/Window.setTimeout#Minimum delay and timeout nesting">varies depending on the situation</a>. In addition, timeouts and intervals are clamped to one per second in inactive tabs (that is, tabs the user isn't currently looking at).</p>
<h2 id="JavaScript_changes">JavaScript changes</h2>
<p>The following keywords are now reserved in JavaScript, even when you're not in <a href="/en/JavaScript/Strict_mode" title="en/JavaScript/Strict mode">strict mode</a>:</p>
<ul> <li><code>class<br> </code></li> <li><code>enum<br> </code></li> <li><code>export<br> </code></li> <li><code>extends<br> </code></li> <li><code>import<br> </code></li> <li><code>super</code></li>
</ul>
<p>Don't use those keywords anywhere in your code, even as object property names.</p>
<div class="note"><strong>Note:</strong> This is one of those things that AMO's automatically upgrade tool may not always catch, so check your code for these if your add-on was automatically upgraded but is still not working properly.</div>
<h2 id="Interface_changes">Interface changes</h2>
<p>Instantiating certain services, including the {{ interface("nsICertOverrideService") }}, at startup can make Firefox unusable ({{ bug(650858) }}. This happens only if you try to instantiate a service before the <code>load</code> event is fired.</p>
<p>To fix this, move your instantiation of these services into your <code>load</code> event handler:</p>
<pre class="brush: js">var MyObject = {
  comp : null,
  init: function() {
    this.comp = Components.classes[...].getService(...);
  },
  ...
}
window.addEventListener("load", function() { MyObject.init(); }, false);
</pre>
<p>An even better solution, of course, is to follow <a href="/en/Extensions/Performance_best_practices_in_extensions" title="en/Extensions/Performance best practices in extensions">performance best practices</a> and to not instantiate services until you need to use them.</p>
<h2 id="See_also">See also</h2>
<ul> <li><a href="/en/Firefox_5_for_developers" title="en/Firefox 5 for developers">Firefox 5 for developers</a></li>
</ul>
